#include <stdio.h>
#include <stdlib.h>
#include "pvm3.h"
#include "constant.h"

int MyID,
TaskNum,
Step,
Count,
Index,
Dummy,
Value,
OldValue,
NewValue,
Message,
BufIndex,
X,
Y,
X2,
Y2,
MaxNum,
MaxX,
MaxY,
MinSurvive,
MinBreed,
MaxTurns,
Buffer[8],
BufferID,
*TaskID,
*TaskValue;
Boolean Running,
Changed,
Logging;
char Par, *Line, Header[50];
char Char[4] = ".oVY";
char *Name[4] = {"termofold", "kaposzta", "nyul", "roka"};
char *ChangedTo[4] = {"de", "va", "la", "va"};
char *AteIt[4] = {"et", "t", "at", "t"};
FILE *Config, *Log;

void ClearScreen(void)
{
  printf("\033[2J\033[0;0f");
  fflush(stdout);
}

void PrintStatus()
{
  printf("\033[0;0f");
  if (Logging && (Step > 0)) fprintf(Log, "%d. lepesben ", Step);
  if (Logging) fprintf(Log, Header);
  Count = 0;
  Running = False;
  for (Y = 0; Y < MaxY; Y++)
  {
    for (X = 0; X < MaxY; X++)
    {
      if (TaskValue[Count] > tvCabbage) Running = True;
      Line[X] = Char[TaskValue[Count]];
      Count++;
    }
    Line[X] = '\n';
    Line[X + 1] = '\0';
    printf(Line);
    if (Logging) fprintf(Log, Line);
  }
  if (Logging) fprintf(Log, "\n");
  if (Step == MaxTurns) Running = False;
  Step++;
}

int main(int argc, char *argv[])
{
  printf("Kaposztak, nyulak es rokak - irta Kovacs Balazs\n\n");
  Logging = False;
  if (argc > 1)
  {
    if (((Par = argv[1][0]) == '-') || (Par == '/'))
    {
      if ((Par = toupper(argv[1][1])) == 'H')
      {
	printf("Ez a program kaposztak, nyulak es rokak  eletet  szimulalja.  A  parameterek  a\n");
	printf("life.cfg nevu szovegfile-ban adhatok meg. A /L kapcsolo hatasara a szimulacio a\n");
	printf("kepernyo mellett a file.log szovegfile-ban is megjelenik.\n\n");
	exit(0);
      }
      if (Par == 'L') Logging = True;
    }
  }
  Config = fopen("life.cfg", "r");
  if (Config != NULL)
  {
    fscanf(Config, "X iranyu szelesseg=%d\n", &MaxX);
    fscanf(Config, "Y iranyu szelesseg=%d\n", &MaxY);
    fscanf(Config, "Minimum tulelesi kaja=%d\n", &MinSurvive);
    fscanf(Config, "Minimum szaporodasi kaja=%d\n", &MinBreed);
    fscanf(Config, "Maximalis lepesek szama=%d\n", &MaxTurns);
    fclose(Config);
    MyID = pvm_mytid();
    if (MyID > 0)
    {
      if (!Logging || ((Log = fopen("life.log", "w")) != NULL))
      {
	printf("Alprogramok elinditasa folyamatban...\n");
	MaxNum = MaxX * MaxY;
	TaskID = calloc(MaxNum, sizeof(int));
	TaskValue = calloc(MaxNum, sizeof(int));
	TaskNum = pvm_spawn("lifetask", NULL, PvmTaskDefault, NULL, MaxNum, TaskID);
	Line = malloc(MaxNum + 2);
	if (TaskNum == MaxNum)
	{
	  for (Index = 0; Index < MaxNum; Index++)
	  {
	    TaskValue[Index] = rand() % 4;
	    pvm_initsend(PvmDataDefault);
	    Buffer[0] = Index;
	    Buffer[1] = TaskValue[Index];
	    Buffer[2] = MinSurvive;
	    Buffer[3] = MinBreed;
	    pvm_pkint(Buffer, 4, 1);
	    pvm_send(TaskID[Index], mtInit);
	  }
	  ClearScreen();
	  Step = 0;
	  strcpy(Header, "Szimulacio kezdete:\n");
	  PrintStatus();
	  Running = True;
	  while (Running)
	  {
	    Changed = False;
	    BufferID = pvm_recv(-1, -1);
	    pvm_bufinfo(BufferID, &Dummy, &Message, &Dummy);
	    switch (Message)
	    {
	     case mtRequest:
	      pvm_upkint(&Index, 1, 1);
	      X = Index % MaxX;
	      Y = Index / MaxX;
	      BufIndex = 0;
	      for (Count = 0; Count < 9; Count++)
	      {
		if (Count != 4)
		{
		  X2 = X - 1 + (Count % 3);
		  Y2 = Y - 1 + (Count / 3);
		  if ((X2 >= 0) && (X2 < MaxX) && (Y2 >= 0) && (Y2 < MaxY))
		  {
		    Buffer[BufIndex] = TaskValue[X2 + (MaxX * Y2)];
		  }
		  else
		  {
		    Buffer[BufIndex] = tvEmpty;
		  }
		  BufIndex++;
		}
	      }
	      pvm_initsend(PvmDataDefault);
	      pvm_pkint(Buffer, 8, 1);
	      pvm_send(TaskID[Index], mtAnswer);
	      break;
	     case mtChanged:
	      pvm_upkint(Buffer, 2, 1);
	      Index = Buffer[0];
	      NewValue = Buffer[1];
	      if (NewValue== tvEmpty) sprintf(Header, "(%d,%d) %s ehenhalt:\n", Index % MaxX + 1, Index / MaxX + 1, Name[TaskValue[Index]]);
	        else sprintf(Header, "(%d,%d) %s atvaltozott %s%s:\n", Index % MaxX + 1, Index / MaxX + 1, Name[TaskValue[Index]], Name[NewValue], ChangedTo[NewValue]);
	      Changed = (TaskValue[Index] != NewValue);
	      TaskValue[Index] = NewValue;
	      break;
	     case mtEat:
	      pvm_upkint(Buffer, 5, 1);
	      Index = Buffer[0];
	      Count = Buffer[1];
	      Value = Buffer[2];
	      OldValue = Buffer[3];
	      NewValue = Buffer[4];
	      X = (Index % MaxX) - 1 + (Count % 3);
	      Y = (Index / MaxX) - 1 + (Count / 3);
	      Count = X + MaxX * Y;
	      if ((TaskValue[Index] == Value) && (TaskValue[Count] == OldValue))
	      {
		if (NewValue == tvEmpty) sprintf(Header, "(%d,%d) %s megette (%d,%d) %s%s:\n", Index % MaxX + 1, Index / MaxX + 1, Name[TaskValue[Index]], X + 1, Y + 1, Name[TaskValue[Count]], AteIt[TaskValue[Count]]);
		  else sprintf(Header, "(%d,%d) %s szaporodott (%d,%d) %s helyere:\n", Index % MaxX + 1, Index / MaxX + 1, Name[TaskValue[Index]], X + 1, Y + 1, Name[TaskValue[Count]]);
		Changed = (TaskValue[Count] != NewValue);
		TaskValue[Count] = NewValue;
		pvm_initsend(PvmDataDefault);
		pvm_pkint(&NewValue, 1, 1);
		pvm_send(TaskID[Count], mtKill);
	      }
	      break;
	    }
	    if (Changed) PrintStatus();
	  }
	  ClearScreen();
	  if (Logging) fprintf(Log, "Szimulacio befejezese\n");
	  pvm_initsend(PvmDataDefault);
	  for (Count = 0; Count < MaxNum; Count++) pvm_send(TaskID[Count], mtExit);
	}
	else
	{
	  printf("Nem tudom elinditani az alprogramokat!\n\n");
	  pvm_exit();
	  exit(-1);
	}
	if (Logging) fclose(Log);
	pvm_exit();
	exit(0);
      }
      else
      {
	printf("Nem tudom letrehozni a listafile-t!\n\n");
	pvm_exit();
	exit(-1);
      }
    }
    else
    {
      printf("Inditsd el a lokalis PVM demont!\n\n");
      exit(-1);
    }
  }
  else
  {
    printf("Nem talalom a konfiguracios file-t!\n\n");
    exit(-1);
  }
}
