#include <stdio.h>
#include <stdlib.h>
#include "pvm3.h"

#include "kozos.h"



/* oszthatosag vizsgalat */
#define osztja(n,x)	(	! ( (x) % (n) )		)



void main(){
	int primem;	/* ez az en sajat primem */
	int sorszam;	/* ennyiedik primet szamolom */
	int maxsorszam;	/* max. ennyi taszk indulhat el */
	int gyoker;	/* a gyoker taszk tid-je */
	int kovetkezo;	/* a kovetkezo taszk tid-je */
	int vege = 0;	/* boolean, az esemenyciklushoz */

	pvm_mytid();

	/* INIT, benne "gyoker", "maxsorszam" es "sorszam"-1 */
	initFogad(&gyoker,&maxsorszam,&sorszam,-1);
	sorszam ++;

	/* az elso kapott szam a "primem" */
	primem = intFogad(-1,SZAM_MSG);

	/* elkuldom "primem" a gyokernek */
	intKuld(primem,gyoker,PRIM_MSG);

	/* elinditok egy ujabb taszkot, "kovetkezo"-t, ha lehet */
	if ( (sorszam<maxsorszam) &&
	     ( 1 == pvm_spawn("prim",(char **)NULL,0,"",1,&kovetkezo) )
	   ) {
		/* elkuldom neki az INIT-et */
		initKuld(gyoker,maxsorszam,sorszam,kovetkezo);
	} else { /* ha nem sikerult, VEGE jel a gyokernek */
		/* benne, hogy hany "prim" taszk van */
		intKuld(sorszam,gyoker,VEGE_MSG);
		vege = 1;	/* igaz, veget akarok erni */
	}

	/* esemenyciklus, SZAM_MSG es STOP_MSG uzenetet varok */
	while (!vege) {
		int hossz, tipus, kuldo;	/* bufinfo-hoz */
		pvm_bufinfo(pvm_recv(-1,-1),&hossz,&tipus,&kuldo);
		if (tipus==SZAM_MSG) {
			/* a beerkezo szamot tesztelem */
			int ujszam;
			pvm_upkint(&ujszam,1,1);
			if (!osztja(primem,ujszam)) {
				/* tovabb kell kuldeni */
				intKuld(ujszam,kovetkezo,SZAM_MSG);
			}
		} else { /* STOP_MSG */
			stopKuld(kovetkezo);
			vege = 1;	/* igaz, veget kell ernem */
		}
	}

	pvm_exit();
	exit(0);
}

