#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pvm3.h>

int main(int argc, char* argv[])
{
    if (argc != 2)
    {
        printf("Use: try <number of children>\n");
        return 1;
    }

    if (argv[1][0] == 's')
    {
        char hn[128];
        gethostname(hn, 128);
        pvm_initsend(PvmDataDefault);
        pvm_pkstr(hn);
        pvm_send(pvm_parent(), 0);
        pvm_exit();
    }
    else
    {
        int i, n = atoi(argv[1]);

        if (n <= 0)
        {
            printf("No children to start.\n");
            return 1;
        }

	printf("Start %d children:\n", n);
        for (i=0; i<n; ++i)
        {
	    char *chldarg[] = {"s", 0};
            int tid;

	    printf("%d", i);fflush(stdout);
            if (pvm_spawn("try", chldarg, PvmTaskDefault,
                        NULL, 1, &tid) < 1)
            {
                pvm_perror("spawn");
                return 1;
            }
	    printf(" ok\n");fflush(stdout);
        }

        for (i=0; i<n; ++i)
        {
            char msg[128];
            pvm_recv(-1, -1);
            pvm_upkstr(msg);
            printf("Msg %d: %s\n", i, msg);
        }

        pvm_exit();
    }

    return 0;
}
